apiVersion: v1
kind: ServiceAccount
metadata:
  name: argo-ui
  namespace: "{{ meta.namespace }}"
  labels:
    app: argo
---
apiVersion: v1
kind: ServiceAccount
metadata:
  name: argo
  namespace: "{{ meta.namespace }}"
  labels:
    app: argo
---
apiVersion: rbac.authorization.k8s.io/v1
kind: Role
metadata:
  name: argo-role
  namespace: "{{ meta.namespace }}"
  labels:
    app: argo
rules:
- apiGroups:
  - ""
  resources:
  - pods
  - pods/exec
  verbs:
  - create
  - get
  - list
  - watch
  - update
  - patch
  - delete
- apiGroups:
  - ""
  resources:
  - configmaps
  verbs:
  - get
  - watch
  - list
- apiGroups:
  - ""
  resources:
  - persistentvolumeclaims
  verbs:
  - create
  - delete
- apiGroups:
  - argoproj.io
  resources:
  - workflows
  - workflows/finalizers
  verbs:
  - get
  - list
  - watch
  - update
  - patch
  - delete
- apiGroups:
  - argoproj.io
  resources:
  - workflowtemplates
  - workflowtemplates/finalizers
  verbs:
  - get
  - list
  - watch
- apiGroups:
  - ""
  resources:
  - serviceaccounts
  verbs:
  - get
  - list
- apiGroups:
  - ""
  resources:
  - secrets
  verbs:
  - get
---
apiVersion: rbac.authorization.k8s.io/v1
kind: Role
metadata:
  name: argo-ui-role
  namespace: "{{ meta.namespace }}"
  labels:
    app: argo
rules:
- apiGroups:
  - ""
  resources:
  - pods
  - pods/exec
  - pods/log
  verbs:
  - get
  - list
  - watch
- apiGroups:
  - ""
  resources:
  - secrets
  verbs:
  - get
- apiGroups:
  - argoproj.io
  resources:
  - workflows
  verbs:
  - get
  - list
  - watch
---
apiVersion: rbac.authorization.k8s.io/v1
kind: RoleBinding
metadata:
  name: argo-binding
  namespace: "{{ meta.namespace }}"
  labels:
    app: argo
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: Role
  name: argo-role
subjects:
- kind: ServiceAccount
  name: argo
---
apiVersion: rbac.authorization.k8s.io/v1
kind: RoleBinding
metadata:
  name: argo-ui-binding
  namespace: "{{ meta.namespace }}"
  labels:
    app: argo
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: Role
  name: argo-ui-role
subjects:
- kind: ServiceAccount
  name: argo-ui
---
apiVersion: v1
data:
  config: |
    namespace: "{{ meta.namespace }}"
    containerRuntimeExecutor: "k8sapi"
    metricsConfig:
      enabled: true
      path: /metrics
      port: 8080
    telemetryConfig:
      enabled: true
      path: /metrics
      port: 8081

kind: ConfigMap
metadata:
  name: workflow-controller-configmap
  namespace: "{{ meta.namespace }}"
  labels:
    app: argo
---
apiVersion: v1
kind: Service
metadata:
  name: argo-ui
  namespace: "{{ meta.namespace }}"
  labels:
    app: argo
spec:
  ports:
  - port: 80
    targetPort: 8001
  selector:
    app: argo-ui
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: argo-ui
  namespace: "{{ meta.namespace }}"
  labels:
    app: argo
spec:
  selector:
    matchLabels:
      app: argo-ui
  template:
    metadata:
      labels:
        app: argo-ui
    spec:
      containers:
      - env:
        - name: FORCE_NAMESPACE_ISOLATION
          value: "true"
        - name: ARGO_NAMESPACE
          valueFrom:
            fieldRef:
              apiVersion: v1
              fieldPath: metadata.namespace
        - name: IN_CLUSTER
          value: "true"
        - name: ENABLE_WEB_CONSOLE
          value: "false"
        - name: BASE_HREF
          value: /
        image: argoproj/argoui:v2.4.2
        name: argo-ui
      serviceAccountName: argo-ui
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: workflow-controller
  namespace: "{{ meta.namespace }}"
  labels:
    app: argo
spec:
  selector:
    matchLabels:
      app: workflow-controller
  template:
    metadata:
      labels:
        app: workflow-controller
    spec:
      containers:
      - args:
        - --configmap
        - workflow-controller-configmap
        - --executor-image
        - argoproj/argoexec:v2.4.2
        command:
        - workflow-controller
        image: argoproj/workflow-controller:v2.4.2
        name: workflow-controller
      serviceAccountName: argo

---
apiVersion: v1
kind: Service
metadata:
  labels:
    app: workflow-controller
  annotations:
    prometheus.io/scrape: 'true'
    prometheus.io/path: '/metrics'
  name: argo-metrics
  namespace: "{{ meta.namespace }}"
spec:
  ports:
  - name: metrics
    port: 8080
    protocol: TCP
    targetPort: 8080
  - name: telemetry
    port: 8081
    protocol: TCP
    targetPort: 8081
  selector:
    app: workflow-controller
  sessionAffinity: None
  type: ClusterIP
